-- =============================================
-- Author:		<Luca,,Name>
-- Create date: <17/11/2008,,>
-- Description:	<Popola la tabella email con i clienti a cui deve essere inviato il report con risorse non associate,,>
-- =============================================
CREATE PROCEDURE [C6MartPeriodico].[RP_DM_GestioneEmailNA]
AS
BEGIN
BEGIN TRANSACTION	
DECLARE @NUMGIORNIDALPERF SMALLINT
DECLARE @NUMGIORNIDASOLLECITO SMALLINT
DECLARE @MaxInvioSoll SMALLINT
DECLARE @ID_ELAB INT
SET @NUMGIORNIDALPERF = CAST(dbo.getParametro('NUMGIORNIDALPERF') as smallint)
SET @NUMGIORNIDASOLLECITO = CAST(dbo.getParametro('NUMGIORNIDASOLLECITO') AS SMALLINT) --7
SET @MaxInvioSoll = CAST(dbo.getParametro('MaxInvioSoll') AS SMALLINT)
SET @ID_ELAB = C6MartPeriodico.GETIDELAB()
-- Log esecuzione
INSERT INTO LOG_ESECUZIONE
	(Nome, Inizio, Nota)
VALUES (
	'RP_DM_GestioneEmailNA',
	GETDATE(),
	'Elaborazione giornaliera'
)
-- 1. INSERIMENTO MAIL "SOLLECITI"
	-- TUPLE DA PERFEZIONARE SU CONTRATTOSEI
	-- E PRESENTI SU GESTIONE_EMAIL
	-- IL PB NON HA EFFETTUATO L'ASSOCIAZIONE DELLE RISORSE
	-- N.B. PER IL PRIMO SOLLECITO DATA_ULTIMOSOLLECITO è NULL -> CONSIDERIAMO DATA_PERF
	INSERT INTO C6MartPeriodico.GESTIONE_EMAIL
		(Rete,Cod_Fiscale,Tipo,Data_Generazione,ID_ELAB)
	SELECT 
		VC.rete,
		VC.cod_fiscale,
		CASE 
			WHEN ISNULL(numSolleciti,0) = 0 THEN '1_SOLL_NOASS'
			WHEN numSolleciti = 1 THEN '2_SOLL_NOASS'
			WHEN numSolleciti = 2 THEN '3_SOLL_NOASS'
			ELSE 'S_SOLL_NOASS'
		END as tipoEmail,
		getDate() as DataGenerazione,
		@ID_ELAB AS ID_ELAB
	FROM C6MartPeriodico.vcontratti VC
		INNER JOIN [C6MartPeriodico].[CONTRATTOSEI_METADATI] MD
		ON MD.chiaveclientepb = VC.chiaveclientepb
	LEFT JOIN C6MartPeriodico.CODICI_PROMOTORI_FITTIZI PF
		ON VC.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
		AND VC.RETE = PF.RETE
	WHERE 1 = 1
		AND MD.numSolleciti < @MaxInvioSoll
		AND (
				(ISNULL(MD.numSolleciti,0) = 0 AND DATEDIFF(DAY,VC.Data_Perf,GETDATE()) >= @NUMGIORNIDALPERF)
				 OR
				(DATEDIFF(DAY,isnull(MD.Data_UltimoSollecito,GETDATE()),GETDATE()) >= @NUMGIORNIDASOLLECITO)
			)	
		AND MD.clienteMigrato = 'S' 
		AND MD.risorseNA = 'S'
		AND VC.Data_FineAvanzato > getDate()
		--AND VC.GenerazioneReport = 'S'
		AND PF.RETE IS NULL
	-- Log esecuzione
	UPDATE
		LOG_ESECUZIONE
	SET
		Fine = GETDATE(),
		Tipo = 'INSERT',
		Righe = @@ROWCOUNT
	WHERE
		Nome = 'RP_DM_GestioneEmailNA' AND
		Inizio = (
			SELECT
				MAX(Inizio)
			FROM
				LOG_ESECUZIONE
			WHERE
				Nome = 'RP_DM_GestioneEmailNA'
		)
	INSERT INTO LOG_ESECUZIONE
		(Nome, Inizio, Nota)
	VALUES (
		'RP_DM_GestioneEmailNA',
		GETDATE(),
		'Elaborazione giornaliera'
	)
-- 1.BIS UPDATE CONTRATTOSEI DOPO INSERIMENTO MAIL "SOLLECITI"
	-- AUMENTIAMO IL NUMERO numSolleciti
	-- AGGIORNIAMO LA DATA Data_UltimoSollecito
	UPDATE 
		C6MartPeriodico.CONTRATTOSEI_METADATI
	SET 
		numSolleciti = isnull(numSolleciti,0) + 1,
		Data_UltimoSollecito = getDate()
	FROM C6MartPeriodico.vcontratti VC
	INNER JOIN [C6MartPeriodico].[CONTRATTOSEI_METADATI] MD
		ON MD.chiaveclientepb = VC.chiaveclientepb
	LEFT JOIN C6MartPeriodico.CODICI_PROMOTORI_FITTIZI PF
		ON VC.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
		AND VC.RETE = PF.RETE
	WHERE 1 = 1
		AND MD.numSolleciti < @MaxInvioSoll
		AND (
				(ISNULL(MD.numSolleciti,0) = 0 AND DATEDIFF(DAY,VC.Data_Perf,GETDATE()) >= @NUMGIORNIDALPERF)
				 OR
				(DATEDIFF(DAY,isnull(MD.Data_UltimoSollecito,GETDATE()),GETDATE()) >= @NUMGIORNIDASOLLECITO)
			)
		AND MD.clienteMigrato = 'S' 
		AND MD.risorseNA = 'S'
		AND VC.Data_FineAvanzato > getDate()
		--AND VC.GenerazioneReport = 'S'
		AND PF.RETE IS NULL
	-- Log esecuzione
	UPDATE
		LOG_ESECUZIONE
	SET
		Fine = GETDATE(),
		Tipo = 'UPDATE',
		Righe = @@ROWCOUNT
	WHERE
		Nome = 'RP_DM_GestioneEmailNA' AND
		Inizio = (
			SELECT
				MAX(Inizio)
			FROM
				LOG_ESECUZIONE
			WHERE
				Nome = 'RP_DM_GestioneEmailNA'
		)
	INSERT INTO LOG_ESECUZIONE
		(Nome, Inizio, Nota)
	VALUES (
		'RP_DM_GestioneEmailNA',
		GETDATE(),
		'Elaborazione giornaliera'
	)
-- 2. INSERIMENTO MAIL "REVOCA"
	-- TUPLE DA PERFEZIONARE SU CONTRATTOSEI
	-- E PRESENTI SU GESTIONE_EMAIL
	-- IL PB NON HA EFFETTUATO L'ASSOCIAZIONE DELLE RISORSE DOPO @MaxInvioSoll SOLLECITI
	-- N.B. OCCHIO ALLA CONDIZIONE -> (c6.risorseNA = 'N' AND numSolleciti = @MaxInvioSoll) OR  numSolleciti > @MaxInvioSoll
	--		OVVERO: BUONA L'ASSOCIAZIONE DELLE RISORSE EFFETTUATA DOPO L'ULTIMO SOLLECITO MA NON DOPO LA PRIMA REVOCA
	INSERT INTO C6MartPeriodico.GESTIONE_EMAIL
		(Rete,Cod_Fiscale,Tipo,Data_Generazione,ID_ELAB)
	SELECT  
		email.rete,
		email.cod_fiscale,
		'REVOCA_NOASS' as tipoEmail,
		getDate() as DataGenerazione,
		@ID_ELAB AS ID_ELAB --max(Data_Generazione)
	FROM C6MartPeriodico.vcontratti VC
		INNER JOIN [C6MartPeriodico].[CONTRATTOSEI_METADATI] MD
			ON MD.chiaveclientepb = VC.chiaveclientepb
	INNER JOIN C6MartPeriodico.gestione_Email EMAIL
		ON VC.RETE = EMAIL.RETE
		AND VC.COD_FISCALE = EMAIL.COD_FISCALE
	LEFT JOIN C6MartPeriodico.CODICI_PROMOTORI_FITTIZI PF
		ON VC.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
		AND VC.RETE = PF.RETE
	WHERE 1 = 1
		AND EMAIL.Tipo IN ('S_SOLL_NOASS','REVOCA_NOASS')	
		AND (
				(MD.numRevoche> 0) -- SONO NEL CASO DI REVOCA SUCCESSIVA BRAVO VALERIO
				OR 
				(MD.numSolleciti = @MaxInvioSoll and MD.risorseNA = 'S')-- SONO NEL CASO DI PRIMA REVOCA
			)
		AND VC.Data_FineAvanzato > getDate()
		--AND VC.GenerazioneReport = 'S'
		AND (DATEDIFF(DAY,isnull(MD.Data_UltimaRevoca,MD.Data_UltimoSollecito),GETDATE()) >= @NUMGIORNIDASOLLECITO)
		AND PF.RETE IS NULL
	GROUP BY email.rete, email.cod_fiscale
	-- Log esecuzione
	UPDATE
		LOG_ESECUZIONE
	SET
		Fine = GETDATE(),
		Tipo = 'INSERT',
		Righe = @@ROWCOUNT
	WHERE
		Nome = 'RP_DM_GestioneEmailNA' AND
		Inizio = (
			SELECT
				MAX(Inizio)
			FROM
				LOG_ESECUZIONE
			WHERE
				Nome = 'RP_DM_GestioneEmailNA'
		)
	INSERT INTO LOG_ESECUZIONE
		(Nome, Inizio, Nota)
	VALUES (
		'RP_DM_GestioneEmailNA',
		GETDATE(),
		'Elaborazione giornaliera'
	)
-- 2.BIS UPDATE CONTRATTOSEI DOPO INSERIMENTO MAIL "REVOCA"
	-- AUMENTIAMO IL NUMERO numSolleciti
	-- NON AGGIORNIAMO LA DATA Data_UltimoSollecito
	-- N.B. VERIFICARE SE IL CAMPO Data_UltimoSollecito VA AGGIORNATO
	UPDATE C6MartPeriodico.[CONTRATTOSEI_METADATI]
	SET 
		numRevoche = isnull(numRevoche,0) + 1,
		data_UltimaRevoca = getDate()
	FROM C6MartPeriodico.vcontratti VC
		INNER JOIN [C6MartPeriodico].[CONTRATTOSEI_METADATI] MD
			ON MD.chiaveclientepb = VC.chiaveclientepb
	INNER JOIN C6MartPeriodico.gestione_Email EMAIL
		ON VC.RETE = EMAIL.RETE
		AND VC.COD_FISCALE = EMAIL.COD_FISCALE
	LEFT JOIN C6MartPeriodico.CODICI_PROMOTORI_FITTIZI PF
		ON VC.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
		AND VC.RETE = PF.RETE
	WHERE 1 = 1
		AND EMAIL.Tipo IN ('S_SOLL_NOASS','REVOCA_NOASS')	
		AND (
				(MD.numRevoche> 0) -- SONO NEL CASO DI REVOCA SUCCESSIVA BRAVO VALERIO
				OR 
				(MD.numSolleciti = @MaxInvioSoll and MD.risorseNA = 'S')-- SONO NEL CASO DI PRIMA REVOCA
			)
		AND VC.Data_FineAvanzato > getDate()
		--AND VC.GenerazioneReport = 'S'
		AND (DATEDIFF(DAY,isnull(MD.Data_UltimaRevoca,MD.Data_UltimoSollecito),GETDATE()) >= @NUMGIORNIDASOLLECITO)
		AND PF.RETE IS NULL
	-- Log esecuzione
	UPDATE
		LOG_ESECUZIONE
	SET
		Fine = GETDATE(),
		Tipo = 'UPDATE',
		Righe = @@ROWCOUNT
	WHERE
		Nome = 'RP_DM_GestioneEmailNA' AND
		Inizio = (
			SELECT
				MAX(Inizio)
			FROM
				LOG_ESECUZIONE
			WHERE
				Nome = 'RP_DM_GestioneEmailNA'
		)
COMMIT
END